import { SerialPort } from "serialport";
import { autoDetect } from "@serialport/bindings-cpp";

const path = "/dev/ttyUSB0";
const serialPort_ = new SerialPort(
  { path, baudRate: 9600, autoOpen: true },
  function (err) {
    if (err) {
      return console.log("Error: ", err.message);
    }
  }
);

console.log(serialPort_);
serialPort_.on("data", (data) => {
  console.log(
    "Received data:",
    data,
    data.toString(),
    data.toString("hex"),
    parseInt("0x" + data.toString("hex").slice(2, -2))
  );
  // Process the response to check if the box was opened successfully
});

serialPort_.on("error", (error) => {
  console.error("Error:", error);
});

async function serialPortList(req, res) {
  const buff = Buffer.from("24"+(+req.params.id).toString(16).padStart(4,'0')+"26", "hex");
  console.log(buff,parseInt("0x" + buff.toString("hex").slice(2, -2)));

  serialPort_.write(buff, function (err, result) {
    if (err) {
      console.log("Error while sending message : " + err);
    }
    if (result) {
      console.log("Response received after sending message : " + result);
    }
  });
  res.send("send:" + parseInt("0x" + buff.toString("hex").slice(2, -2)));
}
async function serialPort(req, res) {
  const buff = Buffer.allocUnsafe(4);
  buff.writeUInt8(`#0${req.params.id}$`);

  const result = await serialport.write(buff);

  res.send(result);

  // serialport.open(function (err) {
  //   if (err) {
  //     return console.log('Error opening port: ', err.message);
  //   }

  //   // Because there's no callback to write, write errors will be emitted on the port:
  //   serialport.write('main screen turn on');
  // })

  // serialport.on('error', function (err) {
  //   console.log('Error: ', err.message);
  // })

  // serialport.on('readable', function () {
  //   console.log('Data:', serialport.read());
  // })

  // serialport.on('data', function (data) {
  //   console.log('Data:', data);
  // })
}

export default serialPortList;
